---
# Gathers facts (bind address) from servers not currently targeted.
# 'delegate_facts' is currently rather buggy in Ansible so this might not
# always work. Hence 'consul_gather_server_facts' defaults to 'no'.
- name: Gather facts from other servers
  setup:
  delegate_to: "{{ host_item }}"
  delegate_facts: true
  with_items: "{{ consul_servers | difference(play_hosts) }}"
  loop_control:
    loop_var: host_item
  ignore_errors: true
  run_once: true
  when: consul_gather_server_facts | bool

- name: Expose advertise_address(_wan) datacenter and node_role as facts
  set_fact:
    consul_advertise_address_wan: "{{ consul_advertise_address_wan }}"
    consul_advertise_address: "{{ consul_advertise_address }}"
    consul_bind_address: "{{ consul_bind_address }}"
    consul_datacenter: "{{ consul_datacenter }}"
    consul_node_role: "{{ consul_node_role }}"

- name: Read bootstrapped state
  stat:
    path: "{{ consul_bootstrap_state }}"
  register: bootstrap_state
  ignore_errors: true
  tags: always

- name: Include user and group settings
  import_tasks: user_group.yml

- name: Install OS packages and consul - from the repository
  include_tasks: install_linux_repo.yml
  when: consul_install_from_repo | bool

- name: Include directory settings
  import_tasks: dirs.yml

- name: Check for existing Consul binary
  stat:
    path: "{{ consul_binary }}"
  register: consul_binary_installed
  when: not consul_force_install

- name: Get current Consul version
  command: "{{ consul_binary }} --version"
  check_mode: false
  changed_when: false
  when:
    - not consul_force_install
    - consul_binary_installed.stat.exists
  register: consul_installed_version

- name: Calculate whether to install consul binary
  set_fact:
    consul_install_binary: "{{ consul_force_install or \
      not consul_binary_installed.stat.exists or \
      consul_installed_version.stdout_lines[0] != _consul_expected_version_string }}"

- name: Install OS packages and consul - locally
  include_tasks: install.yml
  when:
    - consul_install_binary | bool
    - not consul_install_remotely | bool
    - not consul_install_from_repo | bool

- name: Install OS packages and consul - remotely
  include_tasks: install_remote.yml
  when:
    - consul_install_binary | bool
    - consul_install_remotely | bool
    - not consul_install_from_repo | bool

- name: Configure gossip encryption key
  when: consul_encrypt_enable | bool
  block:
    - name: Save existing gossip encryption key
      block:
        - name: Check for gossip encryption key on previously boostrapped server
          slurp:
            src: "{{ consul_config_path }}/config.json"
          register: consul_config_b64
          ignore_errors: true

        - name: Deserialize existing configuration
          set_fact:
            consul_config: "{{ consul_config_b64.content | b64decode | from_json }}"
          when: consul_config_b64.content is defined

        - name: Save gossip encryption key from existing configuration
          set_fact:
            consul_raw_key: "{{ consul_config.encrypt }}"
          no_log: true
          when: consul_config is defined

      when:
        - consul_raw_key is not defined
        - bootstrap_state.stat.exists | bool
        - inventory_hostname in consul_servers

    - name: Create temporary file for raw gossip encryption key
      delegate_to: localhost
      tempfile:
        suffix: ".key"
      become: false
      vars:
        ansible_become: false
      run_once: true
      changed_when: false
      register: consul_raw_key_file

    # Key provided by extra vars or the above block
    - name: Write gossip encryption key locally for use with new servers
      copy:
        content: "{{ consul_raw_key }}"
        dest: "{{ consul_raw_key_file.path }}"
        mode: 0600
      become: false
      vars:
        ansible_become: false
      delegate_to: localhost
      run_once: true
      changed_when: false
      when: consul_raw_key is defined

    - name: Generate new gossip encryption key if none was found
      run_once: true
      when:
        - consul_raw_key is not defined
        - not bootstrap_state.stat.exists | bool
      block:
        - name: Create temporary file to receive gossip encryption key
          become: false
          tempfile:
            state: file
          register: gossip_key_tempfile

        - name: Generate gossip encryption key
          become: true
          shell: "PATH={{ consul_bin_path }}:$PATH consul keygen > /tmp/ansible.owjv7cp_"
          register: consul_keygen

        - name: Fetch key locally to share with other nodes
          become: false
          fetch:
            src: "{{ gossip_key_tempfile.path }}"
            dest: "{{ consul_raw_key_file.path }}"
            flat: true

      always:
        - name: Clean up temporary file
          become: false
          file:
            path: "{{ gossip_key_tempfile.path }}"
            state: absent
          when: gossip_key_tempfile is defined

    - name: Read gossip encryption key for servers that require it
      set_fact:
        consul_raw_key: "{{ lookup('file', consul_raw_key_file.path) }}"
      no_log: true
      when: consul_raw_key is not defined

    - name: Delete gossip encryption key file
      file:
        path: "{{ consul_raw_key_file.path }}"
        state: absent
      become: false
      vars:
        ansible_become: false
      run_once: true
      delegate_to: localhost
      changed_when: false

- name: Create ACL configuration
  include_tasks: acl.yml
  when: consul_acl_enable | bool

- name: Create Consul configuration
  import_tasks: config.yml

- name: Create TLS configuration
  include_tasks: tls.yml
  when: consul_tls_enable | bool

- name: Create syslog configuration
  import_tasks: syslog.yml

- name: Create BSD init script
  template:
    src: consul_bsdinit.j2
    dest: /etc/rc.d/consul
    owner: root
    group: wheel
    mode: 0755
  when: ansible_os_family == "FreeBSD"

- name: Create SYSV init script
  template:
    src: consul_sysvinit.j2
    dest: /etc/init.d/consul
    owner: root
    group: root
    mode: 0755
  when:
    - not ansible_service_mgr == "systemd"
    - not ansible_os_family == "Debian"
    - not ansible_os_family == "FreeBSD"
    - not ansible_os_family == "Solaris"
    - not ansible_os_family == "Darwin"

- name: Create Debian init script
  template:
    src: consul_debianinit.j2
    dest: /etc/init.d/consul
    owner: root
    group: root
    mode: 0755
  when:
    - not ansible_service_mgr == "systemd"
    - ansible_os_family == "Debian"
    - not ansible_os_family == "FreeBSD"
    - not ansible_os_family == "Solaris"
    - not ansible_os_family == "Darwin"

- name: Create systemd script
  template:
    src: consul_systemd.service.j2
    dest: "{{ consul_systemd_unit_path }}/consul.service"
    owner: root
    group: root
    mode: 0644
  register: systemd_unit
  notify: restart consul
  when:
    - ansible_service_mgr == "systemd"
    - not ansible_os_family == "FreeBSD"
    - not ansible_os_family == "Solaris"
    - not ansible_os_family == "Darwin"
    - not consul_install_from_repo | bool

- name: Reload systemd
  systemd:
    daemon_reload: true
  when: systemd_unit is changed

- name: Enable consul at startup (systemd)
  systemd:
    name: consul
    enabled: true
  when:
    - ansible_service_mgr == "systemd"
    - not ansible_os_family == "FreeBSD"
    - not ansible_os_family == "Solaris"
    - not ansible_os_family == "Darwin"

- name: Create launchctl plist file
  template:
    src: "consul_launchctl.plist.j2"
    dest: "{{ consul_launchctl_plist }}"
    mode: "0644"
    validate: "plutil -lint %s"
  when: ansible_os_family == "Darwin"
  notify: restart consul

- name: Create smf manifest
  template:
    src: consul_smf_manifest.j2
    dest: "{{ consul_smf_manifest }}"
    owner: root
    group: root
    mode: 0644
  when: ansible_os_family == "Solaris"
  register: smfmanifest

- name: Import smf manifest
  shell: "svccfg import {{ consul_smf_manifest }}"
  when:
    - smfmanifest is changed
    - ansible_os_family == "Solaris"
  tags: skip_ansible_lint
- name: Import smf script
  shell: "svcadm refresh consul"
  when:
    - smfmanifest is changed
    - ansible_os_family == "Solaris"
  tags: skip_ansible_lint

- name: Enable Consul Snapshots on servers
  include_tasks: snapshot.yml
  when:
    - ansible_service_mgr == "systemd"
    - not ansible_os_family == "FreeBSD"
    - not ansible_os_family == "Solaris"
    - not ansible_os_family == "Darwin"
    - consul_snapshot | bool

- name: Start consul service
  block:

    - name: Start Consul
      service:
        name: consul
        state: started
        enabled: true
        # Needed to force SysV service manager on Docker for Molecule tests
        use: "{{ ansible_service_mgr }}"

    - name: Check Consul HTTP API (via TCP socket)
      wait_for:
        delay: 15
        port: "{{ consul_ports.http|int }}"
        host: "{{ consul_addresses.http }}"
      when: (consul_ports.http|int > -1) and (consul_addresses.http|ansible.utils.ipaddr)

    - name: Check Consul HTTP API (via unix socket)
      wait_for:
        delay: 15
        path: "{{ consul_addresses.http | replace('unix://', '', 1) }}"
      when: consul_addresses.http is match("unix://*")

    - name: Create bootstrapped state file
      file:
        dest: "{{ consul_bootstrap_state }}"
        state: touch
        mode: 0600

    - name: Configure iptables
      include_tasks: ../tasks/iptables.yml
      when: consul_iptables_enable | bool

  when:
    - not bootstrap_state.stat.exists
    - not ansible_os_family == "Darwin"

- name: Configure dnsmasq
  include_tasks: ../tasks/dnsmasq.yml
  when: consul_dnsmasq_enable | bool
